package server;

import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;

public class DataInstance {
	public static DataInstance instance = null;
	HashMap<String, Line> nameindex = new HashMap<String,Line>();
	HashMap<Integer, Line> codeindex = new HashMap<Integer,Line>();
	
	public class Line {
		public Date ts1;
		public String name;
		public Date ts2;
		public Integer code;
		public Date ts3;
		public boolean confirmed;
		
		Line(String name) {
			this.ts1 = new Date();
			this.name = name;
			this.confirmed = false;
		}
		
		@Override
		public String toString() {
			return "<"+name+"|"+ts1+"|"+code+"|"+ts2+"|"+confirmed+"|"+ts3+">";
		}
	}
	
	public static DataInstance getInstance() {
		if (instance == null) {
			instance = new DataInstance();
		}
		return instance;
	}
	
	public Line getLinebyName(String name) {
		return nameindex.get(name);
	}
	
	public Line getLinebyCode(int code) {
		return codeindex.get(code);
	}
	
	public void addLine(String name) {
		nameindex.put(name, new Line(name));
	}
	
	public void addCode(String name, int code) {
		Line myLine = getLinebyName(name);
		if (myLine != null) {
			myLine.ts2 = new Date();
			myLine.code = code;
			this.codeindex.put(code, myLine);
		}
	}
	
	public void confirmCode(int code) {
		Line myLine = codeindex.get(code);
		if (myLine != null) {
			myLine.ts3 = new Date();
			myLine.confirmed = true;
		}
	}
	
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		for (Iterator<Line> iter = nameindex.values().iterator(); iter.hasNext(); )
			sb.append(iter.next()+"\n");
		return sb.toString();
	}
	
}