package server;

import java.io.IOException;

import implementations.RegGen;

import org.apache.xmlrpc.XmlRpcException;
import org.apache.xmlrpc.server.PropertyHandlerMapping;
import org.apache.xmlrpc.server.XmlRpcServer;
import org.apache.xmlrpc.server.XmlRpcServerConfigImpl;
import org.apache.xmlrpc.webserver.WebServer;

public class Server1 implements Runnable {
	public static final int port = 8050;

	public void run() {
		// spust web server
        WebServer webServer = new WebServer(port);
        // ziskej XML-RPC Server
        XmlRpcServer xmlRpcServer = webServer.getXmlRpcServer();
        PropertyHandlerMapping phm = new PropertyHandlerMapping();
        try {
        	phm.addHandler("interfaces.Registrator", RegGen.class);
            phm.addHandler("interfaces.CodeGenerator", RegGen.class);
		} catch (XmlRpcException e) {
			// neco je spatne - napis co
			e.printStackTrace();
		}
        // prirad mapovani
        xmlRpcServer.setHandlerMapping(phm);
        // nastav konfiguraci
        XmlRpcServerConfigImpl serverConfig =
            (XmlRpcServerConfigImpl) xmlRpcServer.getConfig();
        serverConfig.setEnabledForExtensions(true);
        serverConfig.setContentLengthOptional(false);
        // spust server
        try {
			webServer.start();
		} catch (IOException e) {
			// neco je spatne - napis co
			e.printStackTrace();
		}
	}

}
